var MyServo = function(pin, options) {
  this._pin = pin;
  this._skorostValue = 11;
  this._pin.mode('output');
  this._freq = 50;
  this._pulseMin = 0.675;
  this._pulseMax = 2.325;
  this._valueMin = 0;
  this._valueMax = 180;  
  this._skorostValueMax=11;
  this._skorostValueMin=1;
  this._angle=0;
  this._angleNow=0;

  if (options && options.freq) {
    this._freq = options.freq;
  }
  if (options && options.pulseMin) {
    this._pulseMin = options.pulseMin;
  }
  if (options && options.pulseMax) {
    this._pulseMax = options.pulseMax;
  }
  if (options && options.valueMin) {
    this._valueMin = options.valueMin;
  }
  if (options && options.valueMax) {
    this._valueMax = options.valueMax;
  }
  if (options && options.skorostValue) {
    this._skorostValue = options.skorostValue;	
  }
  
  if(this._skorostValue>this._skorostValueMax)
  {
	  this._skorostValue=this._skorostValueMax;
  }
  else if (this._skorostValue<this._skorostValueMin)
  {
	  this._skorostValue=this._skorostValueMin;
  }
  
  if(this._skorostValue===11)
  {
	 this._timeDelay=0;
  }
  else if(this._skorostValue===10)
  {
	 this._timeDelay=5;
  }
  else if(this._skorostValue===9)
  {
	 this._timeDelay=10;
  }
  else if(this._skorostValue===8)
  {
	 this._timeDelay=15;
  }
  else if(this._skorostValue===7)
  {
	 this._timeDelay=20;
  }
  else if(this._skorostValue===6)
  {
	 this._timeDelay=30;
  }
  else if(this._skorostValue===5)
  {
	 this._timeDelay=40;
  }else if(this._skorostValue===4)
  {
	 this._timeDelay=50;
  }
  else if(this._skorostValue===3)
  {
	 this._timeDelay=60;
  }
  else if(this._skorostValue===2)
  {
	 this._timeDelay=80;
  }
  else if(this._skorostValue===1)
  {
	 this._timeDelay=100;
  }
  
  this._period = 1000 / this._freq;
  this._valueStart = this._pulseMin / this._period;
  var pulsDiff = this._pulseMax - this._pulseMin;
  this._valueStep = pulsDiff / (this._valueMax - this._valueMin) / this._period;
};

MyServo.prototype.set = function(value, units) {
  if (value === false) {
    digitalWrite(this._pin, 0);
    return this;
  }
  value=value.toFixed(0);
  this._angleNow=value;
  switch (units) {
    case 'us':
      value = E.clip(value, this._pulseMin * 1000, this._pulseMax * 1000);
      analogWrite(this._pin, value / 1000 / this._period, { freq: this._freq });
      break;
    case 'ms':
      value = E.clip(value, this._pulseMin, this._pulseMax);
      analogWrite(this._pin, value / this._period, { freq: this._freq });
      break;
    default:
      value = E.clip(value, this._valueMin, this._valueMax);
      analogWrite(
        this._pin,
        this._valueStart + this._valueStep * (value - this._valueMin),
        {
          freq: this._freq
        }
      );
  }

  return this;
};



MyServo.prototype.Smooth=function()
{	
    if(this._angleNow<this._angle)
	{
	  this._angleNow++;
	}
	else if(this._angleNow>this._angle)
	{
		this._angleNow--;
	}
	else{clearInterval(this._servoIntervalID);
	this._angle=this._angleNow;
	}	
	
    analogWrite(this._pin, this._valueStart + this._valueStep * (this._angleNow - this._valueMin), {freq: this._freq});
    
}

MyServo.prototype.SmoothSet = function(SmoothValue) {
	
  SmoothValue=SmoothValue.toFixed(0);
  SmoothValue = E.clip(SmoothValue, this._valueMin, this._valueMax);
  this._angle=SmoothValue;
  this._servoIntervalID=setInterval(this.Smooth.bind(this),this._timeDelay);		
}



exports.connect = function(pin, options) {
  return new MyServo(pin, options);
};
